<template>
  <el-dialog v-model="props.modelValue" title="选择商品" width="900px" @closed="closeDialog" @open="openDialog">

    <el-form inline :model="queryParams">
      <el-form-item label="商品名称">
        <el-input v-model='queryParams.goodsName' placeholder='请输入商品名称'></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="handleQuery">
          搜索
        </el-button>
      </el-form-item>
    </el-form>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="goodssList" ref="tableRef" border highlight-current-row
      @row-click="handleRowClick">
      <el-table-column type="selection" width="50" align="center" />
      <el-table-column prop="goodsPicture" width="150" label="图片" align="center">
        <template #default="scope">
          <el-image preview-teleported :hide-on-click-modal="true" lazy class="table-td-thumb" fit="contain"
            :src="scope.row.goodsPicture?.split(',')[0]" :preview-src-list="scope.row.goodsPicture?.split(',')">
            <div><el-icon :size="15">
                <document />
              </el-icon></div>
          </el-image>
        </template>
      </el-table-column>
      <el-table-column prop="goodsName" width="450" label="商品名称" align="left" :show-overflow-tooltip="true" />
      <el-table-column prop="goodsPriceLowest" label="价格" align="center" />
      <el-table-column prop="goodsTotalInventory" label="库存总量" align="center" />

    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getgoodsListFun" />

    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="handleEditClick()">添加</el-button>
        <el-button @click="handleResetClick()">重置</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup>
import { reactive, ref, watch, nextTick } from 'vue';
import { ElMessage } from 'element-plus'
import { goodsList } from '@/api/business/GoodsManager/Goodss/goods.js'

// 业务参数
const total = ref(0)
const loading = ref(false)

// 基础参数
const tableRef = ref(null);
// 查询参数
const queryParams = reactive({
  goodsName: "",
  shopGuid: 0,
  pageNum: 1,
  pageSize: 10
});

const emits = defineEmits(['update:modelValue']);
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  // done: Function,
});
const formData = ref({
  ...props.data
});

const goodssList = ref([]);
// 打开窗口时运行
const openDialog = async () => {


  await getgoodsListFun()
}

/** 搜索按钮操作 */
function handleQuery() {
  getgoodsListFun()
}

const getgoodsListFun = async () => {
  loading.value = true
  await goodsList(queryParams).then((res) => {
    if (res.code == 200) {
      goodssList.value = res.data.result
      total.value = res.data.totalNum
      loading.value = false
    }
  })
}

watch(props, (v) => {
  if (v.data.shopGuid) {
    queryParams.shopGuid = v.data.shopGuid
  }
  formData.value = v.data;
});

// -业务方法
let goodsName = ref("");
let goodsGuid = ref("");


// -基础方法

// 点击行
const handleRowClick = (row) => {
  goodsName.value = row.goodsName
  goodsGuid.value = row.goodsGuid
}

const closeDialog = () => {
  queryParams.goodsName = ""
  goodsName.value = ""
  emits('update:modelValue', false);
};

// 提交 
const handleEditClick = async () => {
  if (goodsName.value !== "") {

    formData.value.goodsName = goodsName.value
    formData.value.goodsGuid = goodsGuid.value
    if (formData.value.goodsName != null) {
      // props.done();
      closeDialog();
    }
  } else {
    ElMessage.error("请选择商品")
    return;
  }
};

const handleResetClick = async formEl => {

};
</script>

